#!/bin/sh

contry=$1
CNTRYISO=$2


if [ "$#" -ne 2 ]; then
    echo 
    echo "***************************************************************************************************************************"
    echo "----------------- You need to provide 2 arguments -------------------------------------------------------------------------"
    echo "***************************************************************************************************************************"
    echo 
    echo "The first is the country name eg : ethiopia or nigeria or philippines, ... "
    echo "The second is the country international ISO CODE eg : ETH (for ethiopia) or NGA(for nigeria) or PHL (for philippines), ... "
    echo 
    echo "The action should be like ..."
    echo
    echo "./deep_purge.sh ethiopia ETH"
    echo              "or"
    echo "./deep_purge.sh ethiopia ETH"
    echo
    exit
fi


#################### Clean all the climate data ###################################################
rm ../input_data/${contry}_latlon
rm ../input_data/${contry}_stns_latlon.txt
rm ../input_data/${contry}_stns_data_cmt.txt

#################### Clean files and folders refering to the specify country ###################################################

rm -rf ts_maps/${contry}
rm -rf spatial_maps/${contry}
rm -rf ${contry}_stns_map

rm -rf ${contry}_index.html
rm -rf ${contry}_*_index.html

rm -rf fix/${contry}_grid.png
rm -rf fix/${contry}_pix_*day_body.html 
rm -rf fix/${contry}_pix_*_body.html 
rm -rf fix/${contry}_stns_pixel_info.txt

rm -rf gis_resources/countries/${CNTRYISO}_adm
rm -rf gis_resources/country_masks0p1/${contry}_*.ctl 
rm -rf gis_resources/country_masks0p1/${contry}_*.dat 
rm -rf gis_resources/country_masks0p036/${contry}_*.ctl 
rm -rf gis_resources/country_masks0p036/${contry}_*.dat
rm -rf gis_resources/country_masks0p5/${contry}_*.ctl 
rm -rf gis_resources/country_masks0p5/${contry}_*.dat 
