#!/bin/bash

byear=$1      #### the first year of the records
nyr=$2        #### total number of year in records
nstations=$3  #### total number of stations in the records

filetxt0="formatted_data.txt"
ymissval=-99999.00
nvar=1        #### EXACT NUMBER OF Variables 

#######################################################################################################

readarray -t indata < "${filetxt0}"  
nlntot=$(cat "${filetxt0}" | wc -l)  	     #### Total Number of Row in the File
nclntot=$nyr 
nout=$nstations 			                 # FINAL NUMBER OF ROWS of the newfile_ready_to_bin.txt






# exit

flag="ok"
ivar=1
while  [ $ivar -le $nvar ]
  do
  iln=2
  while [ $iln -lt $nlntot ]
    do
    echo ${indata[$iln]} | awk '{for (f=1;f<=NF;f++) col[f] = col[f]":"$f} END {for (f=1;f<=NF;f++) print col[f]}' | tr ':' ' ' > bd.txt
    declare -a valn0=(`cat bd.txt`)
#     rm -f bd.txt

    str_time=${valn0[@]}   
    echo "+++++++++++++++++++++++++++++++++ ${str_time} ***************************************************"
exit
    year=$byear
    MTH=0$initMTH
    if [ $ivar -lt 10 ]
      then 
      day=0$ivar
    else
      day=$ivar
    fi

      iarr=$[$ivar+2]
      declare -A PCTS
      PCTS[0]=$year   								# year of records
      PCTS[1]=$MTH  								# Month of records   
      PCTS[2]=$day  								# day of records   
      PCTS[3]=${valn0[0]}   							# station ID
      PCTS[4]=`echo ${valn0[1]} | awk '{ print sprintf("%.17f", $1); }'`  	# station latitude
      PCTS[5]=`echo ${valn0[2]} | awk '{ print sprintf("%.17f", $1); }'`		# station longitude
      PCTS[6]=`echo  ${valn0[$iarr]} | awk '{ print sprintf("%.17f", $1); }'`	# records


      if [ $flag == "ok" ]
	then
	echo "${PCTS[@]}" > newfile_ready_to_bin.txt
      else
	echo "${PCTS[@]}" > newfile1.txt
	cat newfile1.txt >> newfile_ready_to_bin.txt
	rm -f newfile1.txt
      fi

      flag="no"


    iln=$[$iln+1]
  done
  echo "=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/=/="
    ivar=$[$ivar+1]
done


####################################################################################

# -----  rewrite the data again (with format)
# echo $nout $(cat "newfile_ready_to_bin.txt" | wc -l) #### TOTAL NUMBER OF ROW IN THE FILE 
nout=$(cat "newfile_ready_to_bin.txt" | wc -l)       #### TOTAL NUMBER OF ROW IN THE FILE
nrec=$[$nout/$nstations]
# nlntot=$(cat "${filetxt0}" | wc -l)  	#### TOTAL NUMBER OF ROW IN THE FILE
cat > rewrite.f90 << eoffortran

program rewritedata

	integer, parameter :: ir=kkkk
	integer (kind=4) :: year (1:ir), mon(1:ir), day(1:ir)
	character (len=17) :: stn(1:ir)
	real (kind=4) :: lat(1:ir), lon(1:ir)
	real (kind=4) :: var(1:ir)
	integer (kind=4) :: time(1:ir), nlev, nflag

	 open(10,file='newfile_ready_to_bin.txt')
	
	 do i=1,ir
	 read(10,*) year(i), mon(i), day(i), stn(i), lat(i), lon(i), var(i)
	 enddo 
	 
	! putting format to the data

        open(20,file='good_format_newfile_ready_to_bin.txt')
 	
	do i=1,ir
	write(20,200) year(i), mon(i), day(i), stn(i), lat(i), lon(i), var(i)

200     format(i4,2x,i3,2x,i3,4x,a4,6x,f6.2,5x,f6.2,3x,f9.3)  	
	enddo


end program

eoffortran

line1=$(grep ir=kkkk rewrite.f90)
line1a="        integer, parameter :: ir= ${nout} "
sed "s/$line1/$line1a/" rewrite.f90 > rewritedata.f90

gfortran rewritedata.f90
./a.out 

rm -f a.out rewritedata.f90 rewrite.f90
# exit
####################################################################################


cat > mybin.c << EOF
	#include <stdio.h>

	struct rpthdr {
	  char id[8];           /* Character station id  */
	  float lat;            /* Latitude of report             */
	  float lon;            /* Longitude of report            */
	  float t;              /* Time in relative grid units    */
	  int  nlev;            /* Number of levels following     */
	  int flag;             /* Level independent var set flag */
	} hdr;

	void main () {

	  FILE *ifile, *ofile;

	  char rec[80];
	  int flag,year,month,day,yrsav,mnsav,dysav,i;
	  float val;

	  ifile = fopen ("good_format_newfile_ready_to_bin.txt","r");
	  ofile = fopen ("output_good_format.bin","wb");

	  if (ifile==NULL || ofile==NULL) {
	    printf ("Error input file\n");
	    return;
	  }

	  flag = 1;

	  while (fgets(rec,79,ifile) != NULL){

	    sscanf (rec,"%i %i %i",&year,&month,&day);
	    sscanf (rec+28," %g %g %g",&hdr.lat,&hdr.lon,&val);

	    for (i=0;i<8;i++) 
	     hdr.id[i] = rec[i+21];

	     if(flag) {
	     yrsav = year;
	     mnsav = month;
	     dysav = day;
	     flag = 0;
	     }

	     if (yrsav!=year || mnsav!=month || dysav!=day) {
	     hdr.nlev = 0;
	     fwrite (&hdr,sizeof(struct rpthdr), 1, ofile);
	     }
	     yrsav = year; 
	     mnsav = month;
	     dysav = day;

	     hdr.nlev = 1;
	     hdr.flag = 1;
	     hdr.t = 0.0;

	    fwrite (&hdr,sizeof(struct rpthdr), 1, ofile);
	    fwrite (&val,sizeof(float), 1, ofile);
	  }

	  hdr.nlev = 0;
	  fwrite (&hdr,sizeof(struct rpthdr), 1, ofile);
	}

EOF

##################################################################################################################################################
##################################################################################################################################################
##################################################################################################################################################

gfortran mybin.c
./a.out
rm -f a.out mybin.c

mv output_good_format.bin ${prefix}.bin

rm -f newfile_ready_to_bin.txt good_format_newfile_ready_to_bin.txt


#################################################################################
#################################################################################
MTH=${initMTH}

if [ ${MTH} = '1' ]
then 
monchar=Jan
fi

if [ ${MTH} = '2' ]
then 
monchar=Feb
fi

if [ ${MTH} = '3' ]
then 
monchar=Mar
fi

if [ ${MTH} = '4' ]
then 
monchar=Apr
fi

if [ ${MTH} = '5' ]
then 
monchar=May
fi

if [ ${MTH} = '6' ]
then 
monchar=Jun
fi

if [ ${MTH} = '7' ]
then 
monchar=Jul
fi

if [ ${MTH} = '8' ]
then 
monchar=Aug
fi

if [ ${MTH} = '9' ]
then 
monchar=Sep
fi

if [ ${MTH} = '10' ]
then 
monchar=Oct
fi

if [ ${MTH} = '11' ]
then 
monchar=Nov
fi

if [ ${MTH} = '12' ]
then 
monchar=Dec
fi

cat > ${prefix}.ctl << EOF
DSET ${prefix}.bin
DTYPE station
stnmap ${prefix}.map
UNDEF  $ymissval 
TITLE station Data
TDEF $nrec LINEAR 1${monchar}${byear} 1dy
VARS 1
a  0 99     XXXXX YYYYY
ENDVARS
EOF

stnmap -i ${prefix}.ctl

#################################################################################
#################################################################################

