#!/bin/bash
LANG=en_US.utf8 
unameout="$(uname -s)"

nstations=$1
nyr=$2
yrdtastrt=$3
climyrstrt=$4
climyrend=$5


if [ $unameout = "Darwin" ]; then
    opt="bk"
fi

echo 
# echo "========== The total number of station is : $nstations"
echo "Number of Years = " $nyr
echo "Number of Stns = " $nstations
echo "Start Year Data = " $yrdtastrt
echo "Climatological Period  from $climyrstrt to $climyrend" 
echo

sleep 2

echo
echo
echo 'Reformatting Data ...'
echo
echo

sleep 3

rm reformat_map.f reformat_map.exe
cp ../src/template_reformat_map.f reformat_map.f
cp ../input_data/stations.txt .
sed -i $opt "s/NYRS/$nyr/g" reformat_map.f
sed -i $opt "s/NSTNS/$nstations/g" reformat_map.f
sed -i $opt "s/STYR/$yrdtastrt/g" reformat_map.f
clmidx1=`expr $climyrstrt - $yrdtastrt + 1`
clmidx2=`expr $climyrend - $yrdtastrt + 1`
sed -i $opt "s/IDXBGCLM/$clmidx1/g" reformat_map.f
sed -i $opt "s/IDXNDCLM/$clmidx2/g" reformat_map.f
gfortran -o reformat_map.exe reformat_map.f
./reformat_map.exe
rm -f reformat_map.exe reformat_map.f *.fbk
 
# rm reformat.f
# cp ../src/template_reformat.f reformat.f
# cp ../input_data/stations.txt .
# sed -i $opt "s/NYRS/$nyr/g" reformat.f
# sed -i $opt "s/NSTNS/$nstations/g" reformat.f
# sed -i $opt "s/STYR/$yrdtastrt/g" reformat.f
# gfortran -o reformat.exe reformat.f
# ./reformat.exe
# rm -f reformat.exe reformat.f *.fbk

sleep 2
echo
echo
echo 'Computing Climatology ...'
echo
echo 'Writing Data in binary and ASCII formats  ...'
echo
#
echo
echo 'Preparing daily station data for Map plotting  ...'
echo
sleep 1

cp ../src/template_daily_stn2bin.c daily_stn2bin.c
gfortran daily_stn2bin.c
./a.out
rm -f a.out daily_stn2bin.c


cp ../src/template_daily_clim_stn2bin.c daily_clim_stn2bin.c
gfortran daily_clim_stn2bin.c
./a.out
rm -f a.out daily_clim_stn2bin.c

mv data_for_map.bin ../output_data/
mv data_clim_for_map.bin ../output_data/

sleep 1
echo
echo
echo 'Preparing  station data for time series plotting  ...'
echo
sleep 1
#
cp ../src/template_daily_clim.f daily_clim.f
sed -i $opt "s/NYRS/$nyr/g" daily_clim.f
sed -i $opt "s/NSTNS/$nstations/g" daily_clim.f
sed -i $opt "s/ISTR/$yrdtastrt/g" daily_clim.f
clmidx1=`expr $climyrstrt - $yrdtastrt + 1`
clmidx2=`expr $climyrend - $yrdtastrt + 1`
sed -i $opt "s/IDXBGCLM/$clmidx1/g" daily_clim.f
sed -i $opt "s/IDXNDCLM/$clmidx2/g" daily_clim.f
gfortran -o daily_clim.exe daily_clim.f
./daily_clim.exe
rm -f daily_clim.exe daily_clim.f *.fbk
# exit
mv *.bin ../output_data/
mv *.asc ../output_data/

echo
echo
echo ' Done Writing Data ...'
echo
echo ' Creating controlling files ...'
echo
echo
sleep 1


######### control file to manage the Map plotting of the station's daily data #########################
nlntot=$(cat "data_for_map.txt" | wc -l)  	     #### Total Number of Row in the File
nrec=$[$nlntot/$nstations]

cp ../src/template_data_for_map.ctl data_for_map.ctl
sed -i $opt "s/ISTR/$yrdtastrt/g" data_for_map.ctl
sed -i $opt "s/NDAYS/$nrec/g" data_for_map.ctl
rm -f *.ctlbk

stnmap -i data_for_map.ctl    # important step for the mapping of station data

######### control file to manage the time series plotting of the station's daily data ##################
outfile="short_stn_name.txt"
cp ../input_data/stns_latlon.txt .
awk -v val=$outfile '{print $4 "  0 99 ch01  p" > val}' stns_latlon.txt
sed -i $opt -e "1d" $outfile
# nstations=`wc $outfile | awk '{print $1 }'`
#
td=$((365 * $nyr))
cp ../src/template_daily_data.ctl daily_data.ctl
sed -i $opt "s/ISTR/$yrdtastrt/g" daily_data.ctl
sed -i $opt "s/NDAYS/$td/g" daily_data.ctl
sed -i $opt "s/NSTNS/$nstations/g" daily_data.ctl
rm -f *.ctlbk ${outfile}bk
cat daily_data.ctl $outfile > temp.ctl
mv temp.ctl daily_data.ctl
echo "ENDVARS" >> daily_data.ctl
